const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Social_linksDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const social_links = await db.social_links.create(
      {
        id: data.id || undefined,

        network: data.network || null,
        handle: data.handle || null,
        url: data.url || null,
        order_index: data.order_index || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await social_links.setBlock(data.block || null, {
      transaction,
    });

    await social_links.setOrganizations(data.organizations || null, {
      transaction,
    });

    return social_links;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const social_linksData = data.map((item, index) => ({
      id: item.id || undefined,

      network: item.network || null,
      handle: item.handle || null,
      url: item.url || null,
      order_index: item.order_index || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const social_links = await db.social_links.bulkCreate(social_linksData, {
      transaction,
    });

    // For each item created, replace relation files

    return social_links;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const social_links = await db.social_links.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.network !== undefined) updatePayload.network = data.network;

    if (data.handle !== undefined) updatePayload.handle = data.handle;

    if (data.url !== undefined) updatePayload.url = data.url;

    if (data.order_index !== undefined)
      updatePayload.order_index = data.order_index;

    updatePayload.updatedById = currentUser.id;

    await social_links.update(updatePayload, { transaction });

    if (data.block !== undefined) {
      await social_links.setBlock(
        data.block,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await social_links.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return social_links;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const social_links = await db.social_links.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of social_links) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of social_links) {
        await record.destroy({ transaction });
      }
    });

    return social_links;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const social_links = await db.social_links.findByPk(id, options);

    await social_links.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await social_links.destroy({
      transaction,
    });

    return social_links;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const social_links = await db.social_links.findOne(
      { where },
      { transaction },
    );

    if (!social_links) {
      return social_links;
    }

    const output = social_links.get({ plain: true });

    output.block = await social_links.getBlock({
      transaction,
    });

    output.organizations = await social_links.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.blocks,
        as: 'block',

        where: filter.block
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.block
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  type: {
                    [Op.or]: filter.block
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.handle) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('social_links', 'handle', filter.handle),
        };
      }

      if (filter.url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('social_links', 'url', filter.url),
        };
      }

      if (filter.order_indexRange) {
        const [start, end] = filter.order_indexRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            order_index: {
              ...where.order_index,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            order_index: {
              ...where.order_index,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.network) {
        where = {
          ...where,
          network: filter.network,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.social_links.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('social_links', 'network', query),
        ],
      };
    }

    const records = await db.social_links.findAll({
      attributes: ['id', 'network'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['network', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.network,
    }));
  }
};
